const Main = imports.ui.main;
const AltTab = imports.ui.altTab;
const AppIcon = imports.ui.altTab.AppIcon;
const SwitcherPopup = imports.ui.switcherPopup;
const Meta = imports.gi.Meta;
const Shell = imports.gi.Shell;
const Lang = imports.lang;

let oldAppSwitcherInit;

function newAppSwitcherInit(apps, altTabPopup) {
    var parent = Lang.bind(this, SwitcherPopup.SwitcherList.prototype._init);
    parent(true);

    this.icons = [];
    this._arrows = [];

    let windowTracker = Shell.WindowTracker.get_default();
    let allWindows = global.display.get_tab_list(Meta.TabList.NORMAL,
                                                 global.screen, global.screen.get_active_workspace());

    // Construct the AppIcons, add to the popup
    for (let i = 0; i < apps.length; i++) {
        let appIcon = new AppIcon(apps[i]);
        // Cache the window list now; we don't handle dynamic changes here,
        // and we don't want to be continually retrieving it
        appIcon.cachedWindows = allWindows.filter(function(w) {
            return windowTracker.get_window_app (w) == appIcon.app;
        });
        if (appIcon.cachedWindows.length > 0) {
            this._addIcon(appIcon);
        }
    }

    this._curApp = -1;
    this._iconSize = 0;
    this._altTabPopup = altTabPopup;
    this._mouseTimeOutId = 0;

    this.actor.connect('destroy', Lang.bind(this, this._onDestroy));
}

function init() {
    oldAppSwitcherInit = AltTab.AppSwitcher.prototype._init;
}

function enable() {
    AltTab.AppSwitcher.prototype._init = newAppSwitcherInit;
}

function disable() {
    AltTab.AppSwitcher.prototype._init = oldAppSwitcherInit;
}
